// generated by verigenSV.pl on Fri Apr 23 15:00:13 2021
// input file: mesi.cfg

// compiler directives
/* verilator lint_off CASEINCOMPLETE */
/* verilator lint_off DECLFILENAME */
/* verilator lint_off UNUSED */
/* verilator lint_off STMTDLY */
/* verilator lint_off UNOPTFLAT */

module MESI (
	input logic clk,
	input logic res_n,
	input logic [31:0] addr,
	input logic cp,
	input logic rd,
	input logic wr,
	output logic [3:0] mesi, 
	output logic [5:0] index, 
	output logic err, 
	output logic TAG_RAM_status, 
	output logic MESI_RAM_status );

  //
 // parameter constants 
//---------------------------
parameter ZERO = 1'b0;
parameter ONE = 1'b1;
parameter ZERO_MESI = 4'b0000;
parameter ZERO_TAG = 24'h000000;
parameter ZERO_ADDR = 6'b000000;
parameter MODIFIED = 4'b1000;
parameter EXCLUSIVE = 4'b0100;
parameter SHARED = 4'b0010;
parameter INVALID = 4'b0001;


  //
 // state encoding typedef 
//--------------------------------
typedef enum logic [2:0] {
	ID	 = 3'b000,
	RD	 = 3'b001,
	WR	 = 3'b010,
	rRD	 = 3'b101,
	rWR	 = 3'b110
} states_t;


// internal state variables
states_t STATE, NEXT_STATE;


  //
 // memory instantiations 
//---------------------------
logic MESI_RAM_clk; 
logic MESI_RAM_res_n; 
logic MESI_RAM_wr;
logic [5:0] MESI_RAM_wr_addr;
logic [3:0] MESI_RAM_wr_data;
logic MESI_RAM_rd;
logic [5:0] MESI_RAM_rd_addr;
logic [3:0] MESI_RAM_rd_data;
assign MESI_RAM_clk = clk;
assign MESI_RAM_res_n = res_n;
RAM #(4,64) MESI_RAM(.clk(MESI_RAM_clk), .res_n(MESI_RAM_res_n), 
	.wr(MESI_RAM_wr), .wr_addr(MESI_RAM_wr_addr[5:0]), .wr_data(MESI_RAM_wr_data[3:0]), 
	.rd(MESI_RAM_rd), .rd_addr(MESI_RAM_rd_addr[5:0]), .rd_data(MESI_RAM_rd_data[3:0]) );

logic TAG_RAM_clk; 
logic TAG_RAM_res_n; 
logic TAG_RAM_wr;
logic [5:0] TAG_RAM_wr_addr;
logic [23:0] TAG_RAM_wr_data;
logic TAG_RAM_rd;
logic [5:0] TAG_RAM_rd_addr;
logic [23:0] TAG_RAM_rd_data;
assign TAG_RAM_clk = clk;
assign TAG_RAM_res_n = res_n;
RAM #(24,64) TAG_RAM(.clk(TAG_RAM_clk), .res_n(TAG_RAM_res_n), 
	.wr(TAG_RAM_wr), .wr_addr(TAG_RAM_wr_addr[5:0]), .wr_data(TAG_RAM_wr_data[23:0]), 
	.rd(TAG_RAM_rd), .rd_addr(TAG_RAM_rd_addr[5:0]), .rd_data(TAG_RAM_rd_data[23:0]) );


  //
 // implicit continuous assignments 
//----------------------------------
wire IDLE; assign IDLE = ~res_n | (~rd & ~wr);
wire IS_EXCLUSIVE; assign IS_EXCLUSIVE = READ_MESI_RAM(MESI_READ,addr[7:2])==EXCLUSIVE;
wire IS_INVALID; assign IS_INVALID = READ_MESI_RAM(MESI_READ,addr[7:2])==INVALID;
wire IS_MODIFIED; assign IS_MODIFIED = READ_MESI_RAM(MESI_READ,addr[7:2])==MODIFIED;
wire IS_SHARED; assign IS_SHARED = READ_MESI_RAM(MESI_READ,addr[7:2])==SHARED;
wire MESI_READ; assign MESI_READ = WRITE | (TAG_MATCH & (rREAD | rWRITE));
wire MESI_WRITE; assign MESI_WRITE = READ | WRITE | (TAG_MATCH & (rREAD | rWRITE));
wire READ; assign READ = res_n & cp & rd;
wire TAG_MATCH; assign TAG_MATCH = READ_TAG_RAM(TAG_READ,addr[7:2])==addr[31:8];
wire TAG_READ; assign TAG_READ = READ | WRITE | rREAD | rWRITE;
wire TAG_WRITE; assign TAG_WRITE = !TAG_MATCH & READ;
wire WRITE; assign WRITE = res_n & cp & wr;
wire rREAD; assign rREAD = res_n & ~cp & rd;
wire rWRITE; assign rWRITE = res_n & ~cp & wr;


  //
 // initials for simulator
//---------------------------
initial begin
	STATE = ID;
	MESI_RAM_wr = 1'b0;
	MESI_RAM_wr_addr = {6{1'b0}};
	MESI_RAM_wr_data = {4{1'b0}};
	MESI_RAM_rd = 1'b0;
	MESI_RAM_rd_addr = {6{1'b0}};
	TAG_RAM_wr = 1'b0;
	TAG_RAM_wr_addr = {6{1'b0}};
	TAG_RAM_wr_data = {24{1'b0}};
	TAG_RAM_rd = 1'b0;
	TAG_RAM_rd_addr = {6{1'b0}};

  // dump output (Verilator)
  if ($test$plusargs("trace") != 0) begin
    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
    $dumpfile("logs/vlt_dump.vcd");
    $dumpvars();
  end
  $display("[%0t] Model running...\n", $time);


end


  //
 // state transfer
//---------------------------
always_ff @(posedge clk or negedge res_n) begin
  if( !res_n )
    STATE <= ID;
  else
    STATE <= NEXT_STATE;

  // condition for $finish (Verilator)
  if( rd==1'b1 && wr==1'b1 ) begin
    $write("*-* All Finished *-*\n");
    $finish;
  end   

end
// AssertionExample:
//always_ff @ (posedge clk) begin
//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
//end

// coverage analysis (Verilator)
cover property (@(posedge clk) rd==1'b1 && wr==1'b1);

always_comb begin
  unique case ( STATE )
  ID : begin
	// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
	if ( IDLE ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
	if ( READ & TAG_MATCH ) begin
	  NEXT_STATE = RD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=EXCLUSIVE;
	  index=addr[7:2];
	end
	if ( READ & ~TAG_MATCH ) begin
	  NEXT_STATE = RD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=EXCLUSIVE;
	  index=addr[7:2];
	end
	if ( WRITE & TAG_MATCH ) begin
	  NEXT_STATE = WR;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],MODIFIED);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=MODIFIED;
	  index=addr[7:2];
	end
	if ( WRITE & ~TAG_MATCH ) begin
	  NEXT_STATE = WR;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ONE;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
	if ( rWRITE & TAG_MATCH ) begin
	  NEXT_STATE = rWR;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],INVALID);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=INVALID;
	  index=addr[7:2];
	end
	if ( rREAD & TAG_MATCH ) begin
	  NEXT_STATE = rRD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=SHARED;
	  index=addr[7:2];
	end
	if ( rREAD & ~TAG_MATCH ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
  end // ID
  RD : begin
	// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
	if ( IDLE ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
	if ( READ & TAG_MATCH ) begin
	  NEXT_STATE = RD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=EXCLUSIVE;
	  index=addr[7:2];
	end
	if ( READ & ~TAG_MATCH ) begin
	  NEXT_STATE = RD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=EXCLUSIVE;
	  index=addr[7:2];
	end
  end // RD
  WR : begin
	// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
	if ( IDLE ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
	if ( WRITE & TAG_MATCH ) begin
	  NEXT_STATE = WR;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],MODIFIED);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=MODIFIED;
	  index=addr[7:2];
	end
	if ( WRITE & ~TAG_MATCH ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ONE;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
  end // WR
  rRD : begin
	// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
	if ( IDLE ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
	if ( rREAD & TAG_MATCH ) begin
	  NEXT_STATE = rRD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=SHARED;
	  index=addr[7:2];
	end
	if ( rREAD & ~TAG_MATCH ) begin
	  NEXT_STATE = rRD;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=SHARED;
	  index=addr[7:2];
	end
  end // rRD
  rWR : begin
	// ATTENTION: secure that conditions in parallel if-clauses are mutually exclusive to safeguard determinism!
	if ( IDLE ) begin
	  NEXT_STATE = ID;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
	if ( rWRITE & TAG_MATCH ) begin
	  NEXT_STATE = rWR;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],INVALID);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=INVALID;
	  index=addr[7:2];
	end
	if ( rWRITE & ~TAG_MATCH ) begin
	  NEXT_STATE = rWR;
	  // MEMORY action ...
	  TAG_RAM_status = WRITE_TAG_RAM(TAG_WRITE,addr[7:2],ZERO_TAG);
	  MESI_RAM_status = WRITE_MESI_RAM(MESI_WRITE,addr[7:2],ZERO_MESI);
	  // MEALY output action ...
	  err=ZERO;
	  mesi=ZERO_MESI;
	  index=addr[7:2];
	end
  end // rWR
  endcase
end // always_comb


  //
 // memory functions
//---------------------------
function automatic [3:0] READ_MESI_RAM( read, [5:0] read_addr);
   MESI_RAM_rd = read;
   MESI_RAM_rd_addr = read_addr;
   READ_MESI_RAM = MESI_RAM_rd_data;
endfunction

function automatic WRITE_MESI_RAM( write, [5:0] write_addr, [3:0] write_data);
   MESI_RAM_wr = write;
   MESI_RAM_wr_addr = write_addr;
   MESI_RAM_wr_data = write_data;
   WRITE_MESI_RAM = write;
endfunction

function automatic [23:0] READ_TAG_RAM( read, [5:0] read_addr);
   TAG_RAM_rd = read;
   TAG_RAM_rd_addr = read_addr;
   READ_TAG_RAM = TAG_RAM_rd_data;
endfunction

function automatic WRITE_TAG_RAM( write, [5:0] write_addr, [23:0] write_data);
   TAG_RAM_wr = write;
   TAG_RAM_wr_addr = write_addr;
   TAG_RAM_wr_data = write_data;
   WRITE_TAG_RAM = write;
endfunction

endmodule


  //
 // memory
//---------------------------
module RAM ( clk, res_n, wr, wr_addr, wr_data, rd, rd_addr, rd_data );

parameter data_width = 32;
parameter entries = 16;
parameter addr_width = $clog2(entries);

input  wire clk, res_n, rd, wr;
input  wire [data_width-1:0] wr_data;
input  wire [addr_width-1:0] rd_addr, wr_addr;
output wire [data_width-1:0] rd_data;

parameter ZERO_ADDR = {addr_width{1'b0}};
parameter ZERO_DATA = {data_width{1'b0}};
parameter ONE_DATA = {data_width{1'b1}};
    
logic    [data_width-1:0] MEMORY [entries-1:0];

integer i;

initial begin
   // Clear RAM before simulation start
   for ( i = 0; i < entries; i = i + 1 ) begin
       MEMORY[ i ] = ONE_DATA;
   end
end

// IN-CYCLE READ ACCESS
assign rd_data =  ( rd ) ? MEMORY[rd_addr] : 'Z;

always @ ( posedge clk ) begin
    // WRITE ACCESS
   if( wr ) MEMORY[wr_addr] <= wr_data;
end

endmodule
