// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Primary design header
//
// This header should be included by all source files instantiating the design.
// The class here is then constructed to instantiate the design.
// See the Verilator manual for examples.

#ifndef _VMESI_H_
#define _VMESI_H_  // guard

#include "verilated_heavy.h"
#include "verilated_cov.h"

//==========

class VMESI__Syms;
class VMESI_VerilatedVcd;


//----------

VL_MODULE(VMESI) {
  public:
    
    // PORTS
    // The application code writes and reads these signals to
    // propagate new values into/out from the Verilated model.
    VL_IN8(clk,0,0);
    VL_IN8(res_n,0,0);
    VL_IN8(cp,0,0);
    VL_IN8(rd,0,0);
    VL_IN8(wr,0,0);
    VL_OUT8(mesi,3,0);
    VL_OUT8(index,5,0);
    VL_OUT8(err,0,0);
    VL_OUT8(TAG_RAM_status,0,0);
    VL_OUT8(MESI_RAM_status,0,0);
    VL_IN(addr,31,0);
    
    // LOCAL SIGNALS
    // Internals; generally not touched by application code
    CData/*2:0*/ MESI__DOT__STATE;
    CData/*2:0*/ MESI__DOT__NEXT_STATE;
    CData/*0:0*/ MESI__DOT__MESI_RAM_wr;
    CData/*5:0*/ MESI__DOT__MESI_RAM_wr_addr;
    CData/*3:0*/ MESI__DOT__MESI_RAM_wr_data;
    CData/*0:0*/ MESI__DOT__MESI_RAM_rd;
    CData/*5:0*/ MESI__DOT__MESI_RAM_rd_addr;
    CData/*3:0*/ MESI__DOT__MESI_RAM_rd_data;
    CData/*0:0*/ MESI__DOT__TAG_RAM_wr;
    CData/*5:0*/ MESI__DOT__TAG_RAM_wr_addr;
    CData/*0:0*/ MESI__DOT__TAG_RAM_rd;
    CData/*5:0*/ MESI__DOT__TAG_RAM_rd_addr;
    CData/*0:0*/ MESI__DOT__IDLE;
    CData/*0:0*/ MESI__DOT__IS_EXCLUSIVE;
    CData/*0:0*/ MESI__DOT__IS_INVALID;
    CData/*0:0*/ MESI__DOT__IS_MODIFIED;
    CData/*0:0*/ MESI__DOT__IS_SHARED;
    CData/*0:0*/ MESI__DOT__MESI_READ;
    CData/*0:0*/ MESI__DOT__MESI_WRITE;
    CData/*0:0*/ MESI__DOT__READ;
    CData/*0:0*/ MESI__DOT__TAG_MATCH;
    CData/*0:0*/ MESI__DOT__TAG_READ;
    CData/*0:0*/ MESI__DOT__TAG_WRITE;
    CData/*0:0*/ MESI__DOT__WRITE;
    CData/*0:0*/ MESI__DOT__rREAD;
    CData/*0:0*/ MESI__DOT__rWRITE;
    IData/*23:0*/ MESI__DOT__TAG_RAM_wr_data;
    IData/*23:0*/ MESI__DOT__TAG_RAM_rd_data;
    IData/*31:0*/ MESI__DOT__MESI_RAM__DOT__i;
    IData/*31:0*/ MESI__DOT__TAG_RAM__DOT__i;
    CData/*3:0*/ MESI__DOT__MESI_RAM__DOT__MEMORY[64];
    IData/*23:0*/ MESI__DOT__TAG_RAM__DOT__MEMORY[64];
    
    // LOCAL VARIABLES
    // Internals; generally not touched by application code
    // Anonymous structures to workaround compiler member-count bugs
    struct {
        CData/*0:0*/ MESI__DOT____Vtogcov__clk;
        CData/*0:0*/ MESI__DOT____Vtogcov__res_n;
        CData/*0:0*/ MESI__DOT____Vtogcov__cp;
        CData/*0:0*/ MESI__DOT____Vtogcov__rd;
        CData/*0:0*/ MESI__DOT____Vtogcov__wr;
        CData/*3:0*/ MESI__DOT____Vtogcov__mesi;
        CData/*5:0*/ MESI__DOT____Vtogcov__index;
        CData/*0:0*/ MESI__DOT____Vtogcov__err;
        CData/*0:0*/ MESI__DOT____Vtogcov__TAG_RAM_status;
        CData/*0:0*/ MESI__DOT____Vtogcov__MESI_RAM_status;
        CData/*2:0*/ MESI__DOT____Vtogcov__STATE;
        CData/*2:0*/ MESI__DOT____Vtogcov__NEXT_STATE;
        CData/*0:0*/ MESI__DOT____Vtogcov__MESI_RAM_wr;
        CData/*5:0*/ MESI__DOT____Vtogcov__MESI_RAM_wr_addr;
        CData/*3:0*/ MESI__DOT____Vtogcov__MESI_RAM_wr_data;
        CData/*0:0*/ MESI__DOT____Vtogcov__MESI_RAM_rd;
        CData/*5:0*/ MESI__DOT____Vtogcov__MESI_RAM_rd_addr;
        CData/*3:0*/ MESI__DOT____Vtogcov__MESI_RAM_rd_data;
        CData/*0:0*/ MESI__DOT____Vtogcov__TAG_RAM_wr;
        CData/*5:0*/ MESI__DOT____Vtogcov__TAG_RAM_wr_addr;
        CData/*0:0*/ MESI__DOT____Vtogcov__TAG_RAM_rd;
        CData/*5:0*/ MESI__DOT____Vtogcov__TAG_RAM_rd_addr;
        CData/*0:0*/ MESI__DOT____Vtogcov__IDLE;
        CData/*0:0*/ MESI__DOT____Vtogcov__IS_EXCLUSIVE;
        CData/*0:0*/ MESI__DOT____Vtogcov__IS_INVALID;
        CData/*0:0*/ MESI__DOT____Vtogcov__IS_MODIFIED;
        CData/*0:0*/ MESI__DOT____Vtogcov__IS_SHARED;
        CData/*0:0*/ MESI__DOT____Vtogcov__MESI_READ;
        CData/*0:0*/ MESI__DOT____Vtogcov__MESI_WRITE;
        CData/*0:0*/ MESI__DOT____Vtogcov__READ;
        CData/*0:0*/ MESI__DOT____Vtogcov__TAG_MATCH;
        CData/*0:0*/ MESI__DOT____Vtogcov__TAG_READ;
        CData/*0:0*/ MESI__DOT____Vtogcov__TAG_WRITE;
        CData/*0:0*/ MESI__DOT____Vtogcov__WRITE;
        CData/*0:0*/ MESI__DOT____Vtogcov__rREAD;
        CData/*0:0*/ MESI__DOT____Vtogcov__rWRITE;
        CData/*3:0*/ __Vfunc_MESI__DOT__READ_MESI_RAM__0__Vfuncout;
        CData/*3:0*/ __Vfunc_MESI__DOT__READ_MESI_RAM__1__Vfuncout;
        CData/*3:0*/ __Vfunc_MESI__DOT__READ_MESI_RAM__2__Vfuncout;
        CData/*3:0*/ __Vfunc_MESI__DOT__READ_MESI_RAM__3__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__READ_MESI_RAM__3__read;
        CData/*5:0*/ __Vfunc_MESI__DOT__READ_MESI_RAM__3__read_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__READ_TAG_RAM__4__read;
        CData/*5:0*/ __Vfunc_MESI__DOT__READ_TAG_RAM__4__read_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__5__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__6__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__7__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__8__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__9__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__10__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__11__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write;
    };
    struct {
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__12__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__13__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__14__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__15__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__16__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__17__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__18__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__19__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__20__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__21__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__22__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__23__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__24__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__25__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__26__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__27__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__28__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__29__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__30__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__31__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__32__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write_addr;
    };
    struct {
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__33__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__34__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__35__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__36__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__37__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__38__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__39__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__40__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__41__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__42__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__43__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write_addr;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__44__Vfuncout;
        CData/*0:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write;
        CData/*5:0*/ __Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write_addr;
        CData/*0:0*/ __Vclklast__TOP__clk;
        CData/*0:0*/ __Vclklast__TOP__res_n;
        CData/*3:0*/ __Vchglast__TOP__MESI__DOT__MESI_RAM_rd_data;
        IData/*31:0*/ MESI__DOT____Vtogcov__addr;
        IData/*23:0*/ MESI__DOT____Vtogcov__TAG_RAM_wr_data;
        IData/*23:0*/ MESI__DOT____Vtogcov__TAG_RAM_rd_data;
        IData/*23:0*/ __Vfunc_MESI__DOT__READ_TAG_RAM__4__Vfuncout;
        IData/*23:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write_data;
        IData/*23:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write_data;
        IData/*23:0*/ __Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write_data;
        IData/*23:0*/ __Vchglast__TOP__MESI__DOT__TAG_RAM_rd_data;
        CData/*3:0*/ MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[64];
        CData/*0:0*/ __Vm_traceActivity[2];
    };
    
    // INTERNAL VARIABLES
    // Internals; generally not touched by application code
    VMESI__Syms* __VlSymsp;  // Symbol table
  private:
    // Coverage
    void __vlCoverInsert(uint32_t* countp, bool enable, const char* filenamep, int lineno, int column,
        const char* hierp, const char* pagep, const char* commentp, const char* linescovp);
  public:
    
    // CONSTRUCTORS
  private:
    VL_UNCOPYABLE(VMESI);  ///< Copying not allowed
  public:
    /// Construct the model; called by application code
    /// The special name  may be used to make a wrapper with a
    /// single model invisible with respect to DPI scope names.
    VMESI(const char* name = "TOP");
    /// Destroy the model; called (often implicitly) by application code
    ~VMESI();
    /// Trace signals in the model; called by application code
    void trace(VerilatedVcdC* tfp, int levels, int options = 0);
    
    // API METHODS
    /// Evaluate the model.  Application must call when inputs change.
    void eval() { eval_step(); eval_end_step(); }
    /// Evaluate when calling multiple units/models per time step.
    void eval_step();
    /// Evaluate at end of a timestep for tracing, when using eval_step().
    /// Application must call after all eval() and before time changes.
    void eval_end_step();
    /// Simulation complete, run final blocks.  Application must call on completion.
    void final();
    
    // INTERNAL METHODS
  private:
    static void _eval_initial_loop(VMESI__Syms* __restrict vlSymsp);
    void _traceDump();void _traceDumpOpen();void _traceDumpClose();public:
    void __Vconfigure(VMESI__Syms* symsp, bool first);
  private:
    static QData _change_request(VMESI__Syms* __restrict vlSymsp);
    static QData _change_request_1(VMESI__Syms* __restrict vlSymsp);
  public:
    static void _combo__TOP__1(VMESI__Syms* __restrict vlSymsp);
    static void _combo__TOP__7(VMESI__Syms* __restrict vlSymsp);
  private:
    void _configure_coverage(VMESI__Syms* __restrict vlSymsp, bool first) VL_ATTR_COLD;
    void _ctor_var_reset() VL_ATTR_COLD;
  public:
    static void _eval(VMESI__Syms* __restrict vlSymsp);
  private:
#ifdef VL_DEBUG
    void _eval_debug_assertions();
#endif  // VL_DEBUG
  public:
    static void _eval_initial(VMESI__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _eval_settle(VMESI__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _initial__TOP__3(VMESI__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _sequent__TOP__4(VMESI__Syms* __restrict vlSymsp);
    static void _sequent__TOP__5(VMESI__Syms* __restrict vlSymsp);
    static void _settle__TOP__2(VMESI__Syms* __restrict vlSymsp) VL_ATTR_COLD;
    static void _settle__TOP__6(VMESI__Syms* __restrict vlSymsp) VL_ATTR_COLD;
  private:
    static void traceChgSub0(void* userp, VerilatedVcd* tracep);
    static void traceChgTop0(void* userp, VerilatedVcd* tracep);
    static void traceCleanup(void* userp, VerilatedVcd* /*unused*/);
    static void traceFullSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceFullTop0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitSub0(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInitTop(void* userp, VerilatedVcd* tracep) VL_ATTR_COLD;
    void traceRegister(VerilatedVcd* tracep) VL_ATTR_COLD;
    static void traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) VL_ATTR_COLD;
} VL_ATTR_ALIGNED(VL_CACHE_LINE_BYTES);

//----------


#endif  // guard
