// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VMESI__Syms.h"


//======================

void VMESI::_traceDump() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumperp->dump(VL_TIME_Q());
}
void VMESI::_traceDumpOpen() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    if (VL_UNLIKELY(!__VlSymsp->__Vm_dumperp)) {
        __VlSymsp->__Vm_dumperp = new VerilatedVcdC();
        const char* cp = vl_dumpctl_filenamep();
        trace(__VlSymsp->__Vm_dumperp, 0, 0);
        __VlSymsp->__Vm_dumperp->open(vl_dumpctl_filenamep());
        __VlSymsp->__Vm_dumperp->changeThread();
        __VlSymsp->__Vm_dumping = true;
    }
}
void VMESI::_traceDumpClose() {
    const VerilatedLockGuard lock(__VlSymsp->__Vm_dumperMutex);
    __VlSymsp->__Vm_dumping = false;
    VL_DO_CLEAR(delete __VlSymsp->__Vm_dumperp, __VlSymsp->__Vm_dumperp = nullptr);
}
void VMESI::trace(VerilatedVcdC* tfp, int, int) {
    tfp->spTrace()->addInitCb(&traceInit, __VlSymsp);
    traceRegister(tfp->spTrace());
}

void VMESI::traceInit(void* userp, VerilatedVcd* tracep, uint32_t code) {
    // Callback from tracep->open()
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    if (!Verilated::calcUnusedSigs()) {
        VL_FATAL_MT(__FILE__, __LINE__, __FILE__,
                        "Turning on wave traces requires Verilated::traceEverOn(true) call before time 0.");
    }
    vlSymsp->__Vm_baseCode = code;
    tracep->module(vlSymsp->name());
    tracep->scopeEscape(' ');
    VMESI::traceInitTop(vlSymsp, tracep);
    tracep->scopeEscape('.');
}

//======================


void VMESI::traceInitTop(void* userp, VerilatedVcd* tracep) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceInitSub0(userp, tracep);
    }
}

void VMESI::traceInitSub0(void* userp, VerilatedVcd* tracep) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    const int c = vlSymsp->__Vm_baseCode;
    if (false && tracep && c) {}  // Prevent unused
    // Body
    {
        tracep->declBit(c+30,"clk", false,-1);
        tracep->declBit(c+31,"res_n", false,-1);
        tracep->declBus(c+32,"addr", false,-1, 31,0);
        tracep->declBit(c+33,"cp", false,-1);
        tracep->declBit(c+34,"rd", false,-1);
        tracep->declBit(c+35,"wr", false,-1);
        tracep->declBus(c+36,"mesi", false,-1, 3,0);
        tracep->declBus(c+37,"index", false,-1, 5,0);
        tracep->declBit(c+38,"err", false,-1);
        tracep->declBit(c+39,"TAG_RAM_status", false,-1);
        tracep->declBit(c+40,"MESI_RAM_status", false,-1);
        tracep->declBit(c+30,"MESI clk", false,-1);
        tracep->declBit(c+31,"MESI res_n", false,-1);
        tracep->declBus(c+32,"MESI addr", false,-1, 31,0);
        tracep->declBit(c+33,"MESI cp", false,-1);
        tracep->declBit(c+34,"MESI rd", false,-1);
        tracep->declBit(c+35,"MESI wr", false,-1);
        tracep->declBus(c+36,"MESI mesi", false,-1, 3,0);
        tracep->declBus(c+37,"MESI index", false,-1, 5,0);
        tracep->declBit(c+38,"MESI err", false,-1);
        tracep->declBit(c+39,"MESI TAG_RAM_status", false,-1);
        tracep->declBit(c+40,"MESI MESI_RAM_status", false,-1);
        tracep->declBus(c+42,"MESI ZERO", false,-1, 0,0);
        tracep->declBus(c+43,"MESI ONE", false,-1, 0,0);
        tracep->declBus(c+44,"MESI ZERO_MESI", false,-1, 3,0);
        tracep->declBus(c+45,"MESI ZERO_TAG", false,-1, 23,0);
        tracep->declBus(c+46,"MESI ZERO_ADDR", false,-1, 5,0);
        tracep->declBus(c+47,"MESI MODIFIED", false,-1, 3,0);
        tracep->declBus(c+48,"MESI EXCLUSIVE", false,-1, 3,0);
        tracep->declBus(c+49,"MESI SHARED", false,-1, 3,0);
        tracep->declBus(c+50,"MESI INVALID", false,-1, 3,0);
        tracep->declBus(c+41,"MESI STATE", false,-1, 2,0);
        tracep->declBus(c+3,"MESI NEXT_STATE", false,-1, 2,0);
        tracep->declBit(c+30,"MESI MESI_RAM_clk", false,-1);
        tracep->declBit(c+31,"MESI MESI_RAM_res_n", false,-1);
        tracep->declBit(c+4,"MESI MESI_RAM_wr", false,-1);
        tracep->declBus(c+5,"MESI MESI_RAM_wr_addr", false,-1, 5,0);
        tracep->declBus(c+6,"MESI MESI_RAM_wr_data", false,-1, 3,0);
        tracep->declBit(c+7,"MESI MESI_RAM_rd", false,-1);
        tracep->declBus(c+8,"MESI MESI_RAM_rd_addr", false,-1, 5,0);
        tracep->declBus(c+9,"MESI MESI_RAM_rd_data", false,-1, 3,0);
        tracep->declBit(c+30,"MESI TAG_RAM_clk", false,-1);
        tracep->declBit(c+31,"MESI TAG_RAM_res_n", false,-1);
        tracep->declBit(c+10,"MESI TAG_RAM_wr", false,-1);
        tracep->declBus(c+11,"MESI TAG_RAM_wr_addr", false,-1, 5,0);
        tracep->declBus(c+12,"MESI TAG_RAM_wr_data", false,-1, 23,0);
        tracep->declBit(c+13,"MESI TAG_RAM_rd", false,-1);
        tracep->declBus(c+14,"MESI TAG_RAM_rd_addr", false,-1, 5,0);
        tracep->declBus(c+15,"MESI TAG_RAM_rd_data", false,-1, 23,0);
        tracep->declBit(c+16,"MESI IDLE", false,-1);
        tracep->declBit(c+17,"MESI IS_EXCLUSIVE", false,-1);
        tracep->declBit(c+18,"MESI IS_INVALID", false,-1);
        tracep->declBit(c+19,"MESI IS_MODIFIED", false,-1);
        tracep->declBit(c+20,"MESI IS_SHARED", false,-1);
        tracep->declBit(c+21,"MESI MESI_READ", false,-1);
        tracep->declBit(c+22,"MESI MESI_WRITE", false,-1);
        tracep->declBit(c+23,"MESI READ", false,-1);
        tracep->declBit(c+24,"MESI TAG_MATCH", false,-1);
        tracep->declBit(c+25,"MESI TAG_READ", false,-1);
        tracep->declBit(c+26,"MESI TAG_WRITE", false,-1);
        tracep->declBit(c+27,"MESI WRITE", false,-1);
        tracep->declBit(c+28,"MESI rREAD", false,-1);
        tracep->declBit(c+29,"MESI rWRITE", false,-1);
        tracep->declBus(c+51,"MESI MESI_RAM data_width", false,-1, 31,0);
        tracep->declBus(c+52,"MESI MESI_RAM entries", false,-1, 31,0);
        tracep->declBus(c+53,"MESI MESI_RAM addr_width", false,-1, 31,0);
        tracep->declBit(c+30,"MESI MESI_RAM clk", false,-1);
        tracep->declBit(c+31,"MESI MESI_RAM res_n", false,-1);
        tracep->declBit(c+7,"MESI MESI_RAM rd", false,-1);
        tracep->declBit(c+4,"MESI MESI_RAM wr", false,-1);
        tracep->declBus(c+6,"MESI MESI_RAM wr_data", false,-1, 3,0);
        tracep->declBus(c+8,"MESI MESI_RAM rd_addr", false,-1, 5,0);
        tracep->declBus(c+5,"MESI MESI_RAM wr_addr", false,-1, 5,0);
        tracep->declBus(c+9,"MESI MESI_RAM rd_data", false,-1, 3,0);
        tracep->declBus(c+46,"MESI MESI_RAM ZERO_ADDR", false,-1, 5,0);
        tracep->declBus(c+44,"MESI MESI_RAM ZERO_DATA", false,-1, 3,0);
        tracep->declBus(c+54,"MESI MESI_RAM ONE_DATA", false,-1, 3,0);
        tracep->declBus(c+1,"MESI MESI_RAM i", false,-1, 31,0);
        tracep->declBus(c+55,"MESI TAG_RAM data_width", false,-1, 31,0);
        tracep->declBus(c+52,"MESI TAG_RAM entries", false,-1, 31,0);
        tracep->declBus(c+53,"MESI TAG_RAM addr_width", false,-1, 31,0);
        tracep->declBit(c+30,"MESI TAG_RAM clk", false,-1);
        tracep->declBit(c+31,"MESI TAG_RAM res_n", false,-1);
        tracep->declBit(c+13,"MESI TAG_RAM rd", false,-1);
        tracep->declBit(c+10,"MESI TAG_RAM wr", false,-1);
        tracep->declBus(c+12,"MESI TAG_RAM wr_data", false,-1, 23,0);
        tracep->declBus(c+14,"MESI TAG_RAM rd_addr", false,-1, 5,0);
        tracep->declBus(c+11,"MESI TAG_RAM wr_addr", false,-1, 5,0);
        tracep->declBus(c+15,"MESI TAG_RAM rd_data", false,-1, 23,0);
        tracep->declBus(c+46,"MESI TAG_RAM ZERO_ADDR", false,-1, 5,0);
        tracep->declBus(c+45,"MESI TAG_RAM ZERO_DATA", false,-1, 23,0);
        tracep->declBus(c+56,"MESI TAG_RAM ONE_DATA", false,-1, 23,0);
        tracep->declBus(c+2,"MESI TAG_RAM i", false,-1, 31,0);
    }
}

void VMESI::traceRegister(VerilatedVcd* tracep) {
    // Body
    {
        tracep->addFullCb(&traceFullTop0, __VlSymsp);
        tracep->addChgCb(&traceChgTop0, __VlSymsp);
        tracep->addCleanupCb(&traceCleanup, __VlSymsp);
    }
}

void VMESI::traceFullTop0(void* userp, VerilatedVcd* tracep) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlTOPp->traceFullSub0(userp, tracep);
    }
}

void VMESI::traceFullSub0(void* userp, VerilatedVcd* tracep) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode);
    if (false && oldp) {}  // Prevent unused
    // Body
    {
        tracep->fullIData(oldp+1,(vlTOPp->MESI__DOT__MESI_RAM__DOT__i),32);
        tracep->fullIData(oldp+2,(vlTOPp->MESI__DOT__TAG_RAM__DOT__i),32);
        tracep->fullCData(oldp+3,(vlTOPp->MESI__DOT__NEXT_STATE),3);
        tracep->fullBit(oldp+4,(vlTOPp->MESI__DOT__MESI_RAM_wr));
        tracep->fullCData(oldp+5,(vlTOPp->MESI__DOT__MESI_RAM_wr_addr),6);
        tracep->fullCData(oldp+6,(vlTOPp->MESI__DOT__MESI_RAM_wr_data),4);
        tracep->fullBit(oldp+7,(vlTOPp->MESI__DOT__MESI_RAM_rd));
        tracep->fullCData(oldp+8,(vlTOPp->MESI__DOT__MESI_RAM_rd_addr),6);
        tracep->fullCData(oldp+9,(vlTOPp->MESI__DOT__MESI_RAM_rd_data),4);
        tracep->fullBit(oldp+10,(vlTOPp->MESI__DOT__TAG_RAM_wr));
        tracep->fullCData(oldp+11,(vlTOPp->MESI__DOT__TAG_RAM_wr_addr),6);
        tracep->fullIData(oldp+12,(vlTOPp->MESI__DOT__TAG_RAM_wr_data),24);
        tracep->fullBit(oldp+13,(vlTOPp->MESI__DOT__TAG_RAM_rd));
        tracep->fullCData(oldp+14,(vlTOPp->MESI__DOT__TAG_RAM_rd_addr),6);
        tracep->fullIData(oldp+15,(vlTOPp->MESI__DOT__TAG_RAM_rd_data),24);
        tracep->fullBit(oldp+16,(vlTOPp->MESI__DOT__IDLE));
        tracep->fullBit(oldp+17,(vlTOPp->MESI__DOT__IS_EXCLUSIVE));
        tracep->fullBit(oldp+18,(vlTOPp->MESI__DOT__IS_INVALID));
        tracep->fullBit(oldp+19,(vlTOPp->MESI__DOT__IS_MODIFIED));
        tracep->fullBit(oldp+20,(vlTOPp->MESI__DOT__IS_SHARED));
        tracep->fullBit(oldp+21,(vlTOPp->MESI__DOT__MESI_READ));
        tracep->fullBit(oldp+22,(vlTOPp->MESI__DOT__MESI_WRITE));
        tracep->fullBit(oldp+23,(vlTOPp->MESI__DOT__READ));
        tracep->fullBit(oldp+24,(vlTOPp->MESI__DOT__TAG_MATCH));
        tracep->fullBit(oldp+25,(vlTOPp->MESI__DOT__TAG_READ));
        tracep->fullBit(oldp+26,(vlTOPp->MESI__DOT__TAG_WRITE));
        tracep->fullBit(oldp+27,(vlTOPp->MESI__DOT__WRITE));
        tracep->fullBit(oldp+28,(vlTOPp->MESI__DOT__rREAD));
        tracep->fullBit(oldp+29,(vlTOPp->MESI__DOT__rWRITE));
        tracep->fullBit(oldp+30,(vlTOPp->clk));
        tracep->fullBit(oldp+31,(vlTOPp->res_n));
        tracep->fullIData(oldp+32,(vlTOPp->addr),32);
        tracep->fullBit(oldp+33,(vlTOPp->cp));
        tracep->fullBit(oldp+34,(vlTOPp->rd));
        tracep->fullBit(oldp+35,(vlTOPp->wr));
        tracep->fullCData(oldp+36,(vlTOPp->mesi),4);
        tracep->fullCData(oldp+37,(vlTOPp->index),6);
        tracep->fullBit(oldp+38,(vlTOPp->err));
        tracep->fullBit(oldp+39,(vlTOPp->TAG_RAM_status));
        tracep->fullBit(oldp+40,(vlTOPp->MESI_RAM_status));
        tracep->fullCData(oldp+41,(vlTOPp->MESI__DOT__STATE),3);
        tracep->fullBit(oldp+42,(0U));
        tracep->fullBit(oldp+43,(1U));
        tracep->fullCData(oldp+44,(0U),4);
        tracep->fullIData(oldp+45,(0U),24);
        tracep->fullCData(oldp+46,(0U),6);
        tracep->fullCData(oldp+47,(8U),4);
        tracep->fullCData(oldp+48,(4U),4);
        tracep->fullCData(oldp+49,(2U),4);
        tracep->fullCData(oldp+50,(1U),4);
        tracep->fullIData(oldp+51,(4U),32);
        tracep->fullIData(oldp+52,(0x40U),32);
        tracep->fullIData(oldp+53,(6U),32);
        tracep->fullCData(oldp+54,(0xfU),4);
        tracep->fullIData(oldp+55,(0x18U),32);
        tracep->fullIData(oldp+56,(0xffffffU),24);
    }
}
